on doPDC
  if the frameLabel <> "PDC" then
    clearButtons()
  end if
  go("PDC")
  setPdcFromArray()
  updateStage()
end

on doMWC
  if PDCOK() then
    clearButtons()
    go("MWC")
  end if
  updateStage()
end

on doWWC
  if PDCOK() then
    clearButtons()
    go("WWC")
  end if
  updateStage()
end

on doRDA
  if PDCOK() then
    clearButtons()
    go("RDA")
  end if
  updateStage()
end

on dobib
  if PDCOK() then
    clearButtons()
    go("BIB")
  end if
  updateStage()
end

on doBreakfast
  global calcdata
  if PDCOK() then
    if (the frameLabel <> "Breakfast") and (the frameLabel <> "breakfast veg") then
      clearButtons()
    end if
    set vegetarian to getaProp(calcdata, #vegt)
    if vegetarian or getaProp(calcdata, #low_fat) then
      go("Breakfast veg")
      setBreakfastVegFromArray()
    else
      go("Breakfast")
      setBreakfastFromArray()
    end if
  end if
  updateStage()
end

on doLunch
  global calcdata
  if PDCOK() then
    if (the frameLabel <> "Lunch") and (the frameLabel <> "Lunch veg") then
      clearButtons()
    end if
    set vegetarian to getaProp(calcdata, #vegt)
    if vegetarian then
      go("lunch veg")
      setLunchVegFromArray()
    else
      go("lunch")
      setLunchFromArray()
    end if
  end if
  updateStage()
end

on doDinner
  global calcdata
  if PDCOK() then
    if (the frameLabel <> "Dinner") and (the frameLabel <> "Dinner veg") and (the frameLabel <> "Dinner2") and (the frameLabel <> "Dinner2 veg") then
      clearButtons()
    end if
    set vegetarian to getaProp(calcdata, #vegt)
    set twoMeals to getaProp(calcdata, #twoMeals)
    if twoMeals then
      if vegetarian then
        go("dinner2 veg")
        setDinner2VegFromArray()
      else
        go("dinner2")
        setDinner2FromArray()
      end if
    else
      if vegetarian then
        go("dinner veg")
        setDinnerVegFromArray()
      else
        go("dinner")
        setDinnerFromArray()
      end if
    end if
  end if
  updateStage()
end

on doBrunch
  global calcdata
  if PDCOK() then
    if (the frameLabel <> "Brunch") and (the frameLabel <> "Brunch Veg") then
      clearButtons()
    end if
    set vegetarian to getaProp(calcdata, #vegt)
    set lowFat to getaProp(calcdata, #low_fat)
    if vegetarian or lowFat then
      go("brunch veg")
      setBrunchVegFromArray()
    else
      go("brunch")
      setBrunchFromArray()
    end if
  end if
  updateStage()
end
